//
//  MacHiderCMI.h
//  MacHider
//
//  Created by Vira on 8/30/08.
//  Copyright 2008 CleanMyMac. All rights reserved.
//


#include <CoreFoundation/CFPlugInCOM.h>
#include <Carbon/Carbon.h>
#include <CoreFoundation/CFNotificationCenter.h>

/*The unique ID for this plugin:
F3880A0A-E841-11D6-BCEB-000393BA4E08*/

// "40039DD6-1DFD-4891-A455-FB4C3ADE85F7"
#define kCMPlugInFactoryId ( CFUUIDGetConstantUUIDWithBytes( NULL, \
								 0x40, 0x03, 0x9D, 0xD6, 0x1D, 0xFD, 0x48, 0x91, \
								 0xA4, 0x55, 0xFB, 0x4C, 0x3A, 0xDE, 0x85, 0xF7 ))



/*Command IDs*/

enum {
	hideCommandID = 2776,
	restoreCommandID = 2777,
	};


/*One plugin instance.*/

typedef struct tyPlugin {

	ContextualMenuInterfaceStruct	*cmInterface;
	CFUUIDRef factoryId;
	UInt32 refCount;
	} tyPlugin;


/*COM interface*/

static HRESULT queryInterface (void *pluginInstance, REFIID iid, LPVOID *ppv);
static ULONG addRef (void *pluginInstance);
static ULONG release (void *pluginInstance);
extern void* pluginFactory (CFAllocatorRef allocator, CFUUIDRef typeID);


/*COM utility functions*/

static void deallocateInstance (tyPlugin *pluginInstance);
static tyPlugin* allocateInstance (CFUUIDRef factoryId);
static Boolean isGoodInterface (REFIID iid);


/*Contextual menus interface*/

static OSStatus examineContext (void *pluginInstance, const AEDesc *context, AEDescList *commandList);
static OSStatus handleSelection (void *pluginInstance, AEDesc *context, SInt32 commandID);
static void postMenuCleanup (void *pluginInstance );


/*Commands*/
static void runCommand (const AEDesc *desc, const char *command);
static void runHideCommand (const AEDesc *desc);
static void runRestoreCommand (const AEDesc *desc);

/*Menu-building functions.*/

static OSStatus AddCommandToAEDescList(
									   ConstStr255Param	inCommandString,
									   TextEncoding		inEncoding,
									   DescType			inDescType,
									   SInt32				inCommandID,
									   MenuItemAttributes	inAttributes,
									   UInt32				inModifiers,
									   AEDescList*			ioCommandList);
static Boolean addMacHiderCommandToMenu (AEDescList *commandList, int itemBitMask);


/*String utilities*/

static Boolean getCString (char **cStringToGet, CFStringRef cfString, CFStringEncoding encoding);

/*Other utilities.*/

static Boolean isFileOrListOfFiles (const AEDesc *desc);
static Boolean isFileOrFolder (const AEDesc *desc);
static Boolean getFileListAsText (const AEDesc *desc, CFStringRef *fileList);
static void callSystem (CFStringRef command, CFStringRef params);
static void sendUpdateEventToFinder (const AEDesc *desc);
static int isPasswordProtected(); //determine is user chose password protected hiding
/*Contextual menu interface functions struct.*/

static ContextualMenuInterfaceStruct interfaceTable = {

	/*See Menus.h*/
	
	NULL, /*Reserved*/

	/*COM IUnknown interface functions*/
	
	queryInterface,
	addRef,
	release,

	/*Contextual menu interface functions*/
	
	examineContext,
	handleSelection,
	postMenuCleanup
	};
	